' getSpellCheckList.vbs
'========================      =====================================
'         Microsoft Word
'       AkelPad
'========================      =====================================
' 1- : 
'   1 -    ( )
'   2 -     ...
' 2- : 
'   0 -       ( )
'   >File -      File
'   <File -      File     

' 3- : 
'   0|      "0|C:\1.txt|C:\2.txt|C:\3.txt"
'   5|      "5|C:\Fold1\|C:\Fold2\|C:\Fold3\"
'   2 -     
'   3|ListFiles -      /  "3|ListSpell.txt"
'      -      ,     
'      -        
'      -          ,  :
'          - C:\Test\|>txt;ini;bat -         
'          - C:\Test\|<exe;dll;ocx -         
'   3|ListFiles|Section -      /  "3|ListSpell.ini|List1"
'      -     ini   

' 4- :      
'   >     ; ">txt;ini;bat"
'   <      ; "<exe;dll;ocx"

'          %WINDIR% , %COMMANDER_PATH% ...
'========================      ======================================
' -"     ,      " Call("Scripts::Main", 1, "getSpellCheckList.vbs", `1 0 "0|C:\1.txt|C:\2.txt|C:\3.txt"`)
' -"     ,      C:\Result.txt" Call("Scripts::Main", 1, "getSpellCheckList.vbs", `1 ">C:\Result.txt" "0|C:\1.txt|C:\2.txt|C:\3.txt"`)
' -"     ,      C:\Result.txt  " Call("Scripts::Main", 1, "getSpellCheckList.vbs", `1 "<C:\Result.txt" "0|C:\1.txt|C:\2.txt|C:\3.txt"`)

' -"      ,      " Call("Scripts::Main", 1, "getSpellCheckList.vbs", `1 0 "5|C:\1\|C:\Test\"`)
' -"      ,      C:\Result.txt" Call("Scripts::Main", 1, "getSpellCheckList.vbs", `1 ">C:\Result.txt" "5|C:\1\|C:\Test\"`)
' -"      ,      C:\Result.txt  " Call("Scripts::Main", 1, "getSpellCheckList.vbs", `1 "<C:\Result.txt" "5|C:\1\|C:\Test\"`)

' -"        ,      " Call("Scripts::Main", 1, "getSpellCheckList.vbs", `1 0 "5|C:\1\|C:\Test\" ">txt;js;vbs"`)
' -"        ,      C:\Result.txt" Call("Scripts::Main", 1, "getSpellCheckList.vbs", `1 ">C:\Result.txt" "5|C:\1\|C:\Test\" ">txt;js;vbs"`)
' -"        ,      C:\Result.txt  " Call("Scripts::Main", 1, "getSpellCheckList.vbs", `1 "<C:\Result.txt" "5|C:\1\|C:\Test\" ">txt;js;vbs"`)

' -"        ,      " Call("Scripts::Main", 1, "getSpellCheckList.vbs", `1 0 "5|C:\1\|C:\Test\" "<exe;dll;zip"`)
' -"        ,      C:\Result.txt" Call("Scripts::Main", 1, "getSpellCheckList.vbs", `1 ">C:\Result.txt" "5|C:\1\|C:\Test\" "<exe;dll;zip"`)
' -"        ,      C:\Result.txt  " Call("Scripts::Main", 1, "getSpellCheckList.vbs", `1 "<C:\Result.txt" "5|C:\1\|C:\Test\" "<exe;dll;zip"`)

' -"     ,      " Call("Scripts::Main", 1, "getSpellCheckList.vbs", `1 0 2`)
' -"     ,      C:\Result.txt" Call("Scripts::Main", 1, "getSpellCheckList.vbs", `1 ">C:\Result.txt" 2`)
' -"     ,      C:\Result.txt  " Call("Scripts::Main", 1, "getSpellCheckList.vbs", `1 "<C:\Result.txt" 2`)

' -"     ,      " Call("Scripts::Main", 1, "getSpellCheckList.vbs", `1 0 "3|ListSpell.txt"`)
' -"     ,      C:\Result.txt" Call("Scripts::Main", 1, "getSpellCheckList.vbs", `1 ">C:\Result.txt" "3|ListSpell.txt"`)
' -"     ,      C:\Result.txt  " Call("Scripts::Main", 1, "getSpellCheckList.vbs", `1 "<C:\Result.txt" "3|ListSpell.txt"`)

' -"       ,      " Call("Scripts::Main", 1, "getSpellCheckList.vbs", `1 0 "3|ListSpell.ini|MyFiles"`)
' -"       ,      C:\Result.txt" Call("Scripts::Main", 1, "getSpellCheckList.vbs", `1 ">C:\Result.txt" "3|ListSpell.ini|MyFiles"`)
' -"       ,      C:\Result.txt  " Call("Scripts::Main", 1, "getSpellCheckList.vbs", `1 "<C:\Result.txt" "3|ListSpell.ini|MyFiles"`)

'=======================      ====================================
'    .DIC    Microsoft Word
'     \Plugs\SpellCheck\CUSTOM.DIC
'         SpellCheck.js
'     %APPDATA%\Microsoft\UProof\CUSTOM.DIC (C:\Users\\AppData\Roaming\Microsoft\UProof\CUSTOM.DIC -Microsoft Word 2007)
'       -      

'    ,     
'       getSpellCheck.dic      

'  Functions.vbs,     ...AkelFiles\Plugs\Scripts\Include\

' :            
' :          1.3 (03.07.2017 - 07.07.2017)
' Mail:            Averin-And@yandex.ru
' Site:            http://tc-image.3dn.ru/forum/9-1055-18723-16-1499253167
'===========================================================================
With AkelPad If .GetEditWnd = 0 Then WScript.Quit
  .Include("Functions.vbs")
  sResult = ""
  iMode = 1 : sFlag = 0 : Count = 0 : ik = 1 : ssName = "" : sExt = "x" : nDIC = 0
  With WScript Cnt = .Arguments.Count
    If Cnt > 0 Then
      iMode = CInt(.Arguments(0))
      If Cnt > 1 Then
        sFlag = .Arguments(1)
        If Cnt > 2 Then 
          sList  = .Arguments(2) : If Cnt > 3 Then sExt  = .Arguments(3)
        End If
      End If
    End If
  End With
  If Len(sList) < 6 And sList<> "2" Then WScript.Quit
  
  aaList = Split(sList, "|")
  Select Case aaList(0)
    Case 0 '  
    Case 3 '     
      tmp = GetPath(aaList(1))
      If InStr(tmp, ":\") = 0 Then tmp = .GetAkelDir(5) & "\" & tmp
      If Not FFExists(tmp, 1) Then WScript.Quit
      Text = .ReadFile(tmp)
      If Ubound(aaList) > 1 Then Text = TextFormat(GetInfoINI(Text, 2, aaList(2)), 16) ' ,    
      If Text = "" Then WScript.Quit
      aaList = Split(Text, vb)
      Text = ""
      For ij = 0 To Ubound(aaList)
        tmp = ""
        If InStr(aaList(ij),"|") > 0 Then
          aaPath = Split(aaList(ij), "|")
          ssFolder = GetPath(aaPath(0))
          sExt = ";" & Mid(aaPath(1), 2) & ";"
          Select Case Left(aaPath(1), 1)
            Case ">"
              tmp = ListFilesExt(ssFolder, sExt)
            Case "<"
              tmp = ListFilesNoExt(ssFolder, sExt)
          End Select
        ElseIf FFExists(tmp, 2) Then
          tmp = ListFiles(aaList(ij))
        Else
          ssFile = GetPath(aaList(ij))
          If FFExists(ssFile, 1) Then tmp = ssFile
        End If
        If Len(tmp) > 0 Then Text = Text & vb & tmp
      Next
      aaList = Split(Text, vb)
    Case 2 '    
      Text = GetTabList(0, 0, 0)
      aaList = Split(vb & Text, vb)
    Case 5 '    
      Text = ""
      Select Case Left(sExt, 1)
        Case "x" '  
          For ij = 1 To Ubound(aaList)
            tmp = ListFiles(GetPath(aaList(ij)))
            If Len(tmp) > 0 Then Text = Text & vb & tmp
          Next
        Case ">" '   
          sExt = ";" & Mid(sExt, 2) & ";"
          For ij = 1 To Ubound(aaList)
            tmp = ListFilesExt(GetPath(aaList(ij)), sExt)
            If Len(tmp) > 0 Then Text = Text & vb & tmp
          Next
        Case "<" '    
          sExt = ";" & Mid(sExt, 2) & ";"
          For ij = 1 To Ubound(aaList)
            tmp = ListFilesNoExt(GetPath(aaList(ij)), sExt)
            If Len(tmp) > 0 Then Text = Text & vb & tmp
          Next
      End Select
      If Text = "" Then WScript.Quit
      aaList = Split(Text, vb)
  End Select
  
  On Error Resume Next
  Set oWD = CreateObject("Word.Application")
  If Err.Number <> 0 Then MsgBox "Microsoft Word  " , vbOKOnly , "" : QuitWord : WScript.Quit : End If
  oWD.Visible = False
  oWD.Documents.Add "", 0, 0
  Set oSys = .SystemFunction : hMainWnd = AkelPad.GetMainWnd : All = Ubound(aaList) : SetTitle
  
  tmp = .GetAkelDir(5) & "\getSpellCheck.dic" '   
  If FFExists(tmp, 1) Then
    sDIC = .ReadFile(tmp)
    If Len(sDIC) > 0 Then 
      nDIC = 1
      sDIC = vb & sDIC & vb
    End If
  End If
  
  For ik = 1 To All
    aaList(ik) = GetPath(aaList(ik)) : ssName = GetFF(aaList(ik), 3) : SetTitle : ssText = .ReadFile(aaList(ik))
    If Len(ssText) > 5 Then
      
      Select Case iMode
        Case 1 arText = RegExpSearchPlus(ssText, "([-]+[a-z-]?[-]+)", 1, 1, 1, "6>2")
        Case 2
      End Select
      If IsArray(arText) Then
        arText = DelDublicateArr(arText) : Count = Ubound(arText)
        
        If Count > 0 Then
          Text = ""
          For jk = 0 To Count
            Result = oWD.CheckSpelling(arText(jk))
            If Not Result Then
              If nDIC = 1 Then
                If InStr(sDIC,vb & arText(jk) & vb) = 0 Then Text = Text & arText(jk) & vb
              Else
                Text = Text & arText(jk) & vb
              End If
            End If
            SetTitle
          Next
          If Len(Text) > 0 Then sResult = sResult & "[" & aaList(ik) & "]" & vb & Text & vb
        End If
      End If
    End If
  Next
  

  If Len(sResult) > 0 Then
    Select Case Left(sFlag, 1)
      Case "0" '   
        CreateNewTab : SetRedraw .GetEditWnd, False
        .ReplaceSel(sResult) : ScrolEnd : .SetSel 0, 0
        oWD.Quit : Set oWD=Nothing : RecoveTitle : EndRedraw
      Case ">" '    
        SaveTextFile Mid(sFlag, 2), sResult, 65001
      Case "<" '      
        sFile = Mid(sFlag, 2)
        SaveTextFile sFile, sResult, 65001
        .OpenFile sFile
    End Select
  Else
    Wscript.Echo "   "
  End If
End With
QuitWord
WScript.Quit

Sub SetTitle
  oSys.Call "User32::SetWindowTextW", hMainWnd, "getSpellCheckList.vbs :: : " & All & " :: : " & ik - 1 & " :: : " & Round((ik - 1) * 100/ All) & "% :: : " & ssName & "   " & Round(jk * 100/ Count) & "%   "
End Sub

Sub RecoveTitle
  oSys.Call "User32::SetWindowTextW", hMainWnd, "AkelPad"
End Sub
  
Sub QuitWord : oWD.Quit : Set oWD=Nothing : RecoveTitle : End Sub