' getSpellCheck.vbs
'========================      =====================================
'        Microsoft Word
'    ,   
'       
'========================      =====================================
' 1- : 
'   1 -    ( )
'   2 -     ...
' 2- : 
'   1 -       ( )
'   2 -     
'   3 -       3-  "#FFFFFF|#000000" ( | )
'========================      ======================================
' -"    ,      " Call("Scripts::Main", 1, "getSpellCheck.vbs")
' -"    ,    " Call("Scripts::Main", 1, "getSpellCheck.vbs", `1 2`)
' -"    ,     " Call("Scripts::Main", 1, "getSpellCheck.vbs", `1 3 "#FFC1C1|#A54700"`)
'=======================      ====================================
'    .DIC    Microsoft Word
'     \Plugs\SpellCheck\CUSTOM.DIC
'         SpellCheck.js
'     %APPDATA%\Microsoft\UProof\CUSTOM.DIC (C:\Users\\AppData\Roaming\Microsoft\UProof\CUSTOM.DIC -Microsoft Word 2007)
'       -      

'    ,     
'       getSpellCheck.dic      

'  Functions.vbs,     ...AkelFiles\Plugs\Scripts\Include\

' :            
' :          1.2 (18.06.2017 - 07.07.2017)
' Mail:            Averin-And@yandex.ru
' Site:            http://tc-image.3dn.ru/forum/9-1053-18676-16-1497789204
'===========================================================================
With AkelPad If .GetEditWnd = 0 Then WScript.Quit
  .Include("Functions.vbs") : tTxt = .GetSelText()
  If Len(tTxt) = 0 Then tTxt = .GetTextRange(0, -1)
  If Len(tTxt) = 0 Then Wscript.Quit
  
  On Error Resume Next
  Set oWD = CreateObject("Word.Application")
  If Err.Number <> 0 Then MsgBox "Microsoft Word  " , vbOKOnly , "" : QuitWord : WScript.Quit : End If
  oWD.Visible = False
  oWD.Documents.Add "", 0, 0
  
  Mode = 1 : Flag = 1 : Color = "" : k = 0 : All = 0 : Count = 0 : i = 0 : nDIC = 0 : SetTitle
  With WScript Cnt = .Arguments.Count
    If Cnt > 0 Then
      Mode = CInt(.Arguments(0))
      If Cnt > 1 Then
        Flag = CInt(.Arguments(1)) : If Cnt > 2 Then Color  = .Arguments(2) 
      End If
    End If
  End With
  
  Select Case Mode
    Case 1
      ' aText = RegExpSearchPlus(tTxt, "[-]+", 1, 1, 1, "6>2")
      aText = RegExpSearchPlus(tTxt, "([-]+[a-z-]?[-]+)", 1, 1, 1, "6>2")
    Case 2
      ' aText = RegExpSearchPlus(tTxt, "([a-z]+[--]?[a-z]+)", 1, 1, 1, "6>2")
    Case 3
  End Select
  All = Ubound(aText)
  If All < 1 Then MsgBox "   " , vbOKOnly , "" : QuitWord : WScript.Quit : End If
  
  SetTitle
  aText = DelDublicateArr(aText)
  
  If InStr(Color, "|") > 0 Then : aColor = Split(Color, "|") : Flag = 3 : End If

  If Flag > 1 Then
    IsCoderPlugin
    If Flag = 2 Then Dim T(123), F(123) : ArrayMarker : End If
  End If
  
  Set oSys = .SystemFunction : hMainWnd = AkelPad.GetMainWnd : Count = Ubound(aText)
  
  tmp = .GetAkelDir(5) & "\getSpellCheck.dic" '   
  If FFExists(tmp, 1) Then
    sDIC = .ReadFile(tmp)
    If Len(sDIC) > 0 Then 
      nDIC = 1
      sDIC = vb & sDIC & vb
    End If
  End If
  
  For i = 0 To Count
    Result = oWD.CheckSpelling(aText(i))
    If Not Result Then
      tmp = True
      If nDIC = 1 Then
        If InStr(sDIC,vb & aText(i) & vb) > 0 Then tmp = False
      End If
      If tmp Then
        Select Case Flag
          Case 1
            Text = Text & aText(i) & vb
          Case 2
            m = i - Int(i/123)*123 : .Call CF, 2, T(m), F(m) , 0, 0, i + 1, aText(i)
          Case 3
            .Call CF, 2, aColor(0), aColor(1) , 0, 0, i + 1, aText(i)
        End Select
        k = k + 1
      End If
    End If
    SetTitle
  Next
  If k>0 Then
    If Flag = 1 Then '   
      CreateNewTab : SetRedraw .GetEditWnd, False
      .ReplaceSel(Text) : ScrolEnd : .SetSel 0, 0
      oWD.Quit : Set oWD=Nothing : RecoveTitle : EndRedraw
    End If
  Else
    Wscript.Echo "   "
  End If
End With
QuitWord
WScript.Quit

Sub SetTitle
  oSys.Call "User32::SetWindowTextW", hMainWnd, "getSpellCheck.vbs :: : " & All & " ::  : " & Count & " :: : " & i & " :: : " & Round(i *100/ Count) & "% :: : " & k & "   "
End Sub

Sub RecoveTitle
  oSys.Call "User32::SetWindowTextW", hMainWnd, "AkelPad"
End Sub
  
Sub QuitWord : oWD.Quit : Set oWD=Nothing : RecoveTitle : End Sub